import sys , os
from PyQt5 import QtWidgets, QtGui, QtCore
from PyQt5.QtGui import QBrush, QColor
from libabr import res
from libnam import files, control

class MainApp (QtWidgets.QWidget):
    def format (self,it,text):
        if os.path.isdir(self.dir + '/' + text):
            it.setIcon(QtGui.QIcon(res.get('@logo/folder')))
        else:
            format = it.whatsThis().split('.')
            format = max(format)
            if it.whatsThis().endswith(format):
                logo = control.read_record(format + '.logo', '/etc/ext')
                if not logo==None:
                    it.setIcon(QtGui.QIcon(res.get(logo)))
                else:
                    it.setIcon(QtGui.QIcon(res.get('@logo/gtk-file')))
            else:
                it.setIcon(QtGui.QIcon(res.get('@logo/gtk-file')))

    def __init__(self,args):
        super().__init__()

        self.Backend = args[0]
        self.Env = args[1]
        self.Desktop = args[2]
        self.Widget = args[3]

        self.Widget.setWindowTitle ("Kesho File manager")
        self.Widget.setWindowIcon (QtGui.QIcon(res.get('@logo/kesho')))
        self.Widget.resize (1000,600)
        lay = QtWidgets.QVBoxLayout(self)

        self.listView = QtWidgets.QListView()
        lay.addWidget(self.listView)

        self.entry = QtGui.QStandardItemModel()
        self.parentdir = QtGui.QStandardItem()
        self.parentdir.setIcon(QtGui.QIcon(res.get('@logo/folder')))
        self.entry.appendRow(self.parentdir)
        self.listView.setModel(self.entry)
        self.listView.setIconSize(QtCore.QSize(64,64))
        self.listView.clicked[QtCore.QModelIndex].connect(self.on_clicked)
        # When you receive the signal, you call QtGui.QStandardItemModel.itemFromIndex()
        # on the given model index to get a pointer to the item

        self.dir = files.input ('.')
        self.listdir = (os.listdir(self.dir))
        self.listdir.sort()

        for text in self.listdir:
            it = QtGui.QStandardItem(text)
            it.setWhatsThis(self.dir+"/"+text)
            self.format(it,text)
            self.entry.appendRow(it)

        self.itemOld = QtGui.QStandardItem("text")

    def on_clicked(self, index):
        self.item = self.entry.itemFromIndex(index)

        x = hasattr(self.item,'whatsThis') # W3CSHCOOL.COM LEARN IT

        if x == True:

            if self.item.whatsThis() == "<parent>":
                arraydir = self.dir.split('/')
                length = len(arraydir) - 1
                arraydir.pop(length)

                dir = './'
                for i in arraydir:
                    dir += '/' + i

                self.dir = dir
                self.listdir = os.listdir(self.dir)
                self.listdir.sort() # Credit: https://www.geeksforgeeks.org/sort-in-python/

                self.entry = QtGui.QStandardItemModel()
                self.listView.setModel(self.entry)
                self.listView.setIconSize(QtCore.QSize(64, 64))
                self.listView.clicked[QtCore.QModelIndex].connect(self.on_clicked)
                self.parentdir = QtGui.QStandardItem()
                self.parentdir.setIcon(QtGui.QIcon(res.get('@logo/folder')))
                self.parentdir.setWhatsThis('<parent>')
                self.entry.appendRow(self.parentdir)

                for text in self.listdir:
                    it = QtGui.QStandardItem(text)
                    it.setWhatsThis(self.dir + "/" + text)
                    self.format(it,text)
                    self.entry.appendRow(it)

            elif os.path.isdir(self.item.whatsThis()):
                self.dir = self.item.whatsThis()
                self.listdir = os.listdir(self.dir)
                self.listdir.sort()

                self.entry = QtGui.QStandardItemModel()
                self.listView.setModel(self.entry)
                self.listView.setIconSize(QtCore.QSize(64, 64))
                self.listView.clicked[QtCore.QModelIndex].connect(self.on_clicked)
                self.parentdir = QtGui.QStandardItem()
                self.parentdir.setIcon(QtGui.QIcon(res.get('@logo/folder')))
                self.parentdir.setWhatsThis('<parent>')
                self.entry.appendRow(self.parentdir)

                for text in self.listdir:
                    it = QtGui.QStandardItem(text)
                    it.setWhatsThis(self.dir + "/" + text)
                    self.format(it,text)
                    self.entry.appendRow(it)