from PyQt5 import QtWidgets, uic, QtGui, QtCore
import sys, importlib
from libabr import core,app as apps,res, file, core
from libnam import files, modules,control
import app, importlib

class MainApp(QtWidgets.QMainWindow):
    def __init__(self,args):
        super(MainApp, self).__init__()

        self.Backend = args[0]
        self.Env = args[1]
        self.Desktop = args[2]
        self.Widget = args[3]
        ## Disable max min ##
        self.Widget.disableMaximizeButton()
        self.Widget.disableMinimizeButton()

        uic.loadUi(res.get('@widget/pysys'),self)

        ## Widget configs ##
        self.Widget.setWindowTitle (res.get('@string/app_name'))
        self.Widget.setWindowIcon (QtGui.QIcon(res.get('@logo/pysys')))
        self.Widget.resize (558,550)

        ## Finds ##
        self.btnSuspend = self.findChild(QtWidgets.QPushButton,'btnSuspend')
        self.btnEscape = self.findChild(QtWidgets.QPushButton, 'btnEscape')
        self.btnRestart = self.findChild(QtWidgets.QPushButton, 'btnRestart')
        self.btnLogout = self.findChild(QtWidgets.QPushButton, 'btnLogout')
        self.btnSwitchuser = self.findChild(QtWidgets.QPushButton, 'btnSwitchuser')
        self.btnLock = self.findChild(QtWidgets.QPushButton, 'btnLock')


        self.lblSuspend = self.findChild(QtWidgets.QLabel, 'lblSuspend')
        self.lblEscape = self.findChild(QtWidgets.QLabel, 'lblEscape')
        self.lblRestart = self.findChild(QtWidgets.QLabel, 'lblRestart')
        self.lblLogout = self.findChild(QtWidgets.QLabel, 'lblLogout')
        self.lblSwitchuser = self.findChild(QtWidgets.QLabel, 'lblSwitchuser')
        self.lblLock = self.findChild(QtWidgets.QLabel, 'lblLock')

        # Set all labels text #
        self.lblSuspend.setText (res.get('@string/suspend'))
        self.lblEscape.setText(res.get('@string/escape'))
        self.lblLock.setText(res.get('@string/lock'))
        self.lblLogout.setText(res.get('@string/logout'))
        self.lblRestart.setText(res.get('@string/restart'))
        self.lblSwitchuser.setText(res.get('@string/switchuser'))

        # Set all buttons icon #
        self.btnEscape.setStyleSheet ('background-color: #ABCDEF;background-image: url('+res.get('@logo/pysys_escape')+");border-radius: 64% 64%;")
        self.btnLock.setStyleSheet('background-color: #ABCDEF;background-image: url(' + res.get('@logo/pysys_lock') + ");border-radius: 64% 64%;")
        self.btnLogout.setStyleSheet(
            'background-color: #ABCDEF;background-image: url(' + res.get('@logo/pysys_logout') + ");border-radius: 64% 64%;")
        self.btnRestart.setStyleSheet(
            'background-color: #ABCDEF;background-image: url(' + res.get('@logo/pysys_restart') + ");border-radius: 64% 64%;")
        self.btnSuspend.setStyleSheet(
            'background-color: #ABCDEF;background-image: url(' + res.get('@logo/pysys_suspend') + ");border-radius: 64% 64%;")
        self.btnSwitchuser.setStyleSheet(
            'background-color: #ABCDEF;background-image: url(' + res.get('@logo/pysys_switchuser') + ");border-radius: 64% 64%;")

        ## Connects ##
        self.btnSwitchuser.clicked.connect (self.Switchuser_act)
        self.btnLock.clicked.connect(self.Lock_act)
        self.btnLogout.clicked.connect(self.Logout_act)
        self.btnEscape.clicked.connect(self.Escape_act)
        self.btnSuspend.clicked.connect(self.Suspend_act)
        self.btnRestart.clicked.connect(self.Restart_act)

    def Escape_act(self):
        if self.Backend.objectName()=='backend':
            core.shutdown()
            exit(0)
        else:
            self.Backend.taskbar.show()
            self.Env.close()

    def Restart_act(self):
        core.reboot()
        exit(0)

    def Logout_act (self):
        self.type = control.read_record("login.type", "/etc/gui")
        if self.type == "default":
            apps.switch('desktop')
            import default
            self.Backend.setCentralWidget(default.MainApp(self.Backend))
        else:
            exit(0)

    def Switchuser_act (self):
        self.type = control.read_record("login.type", "/etc/gui")
        if self.type == "default":
            apps.switch('desktop')
            import default
            self.Env.taskbar.hide()
            self.Env.setCentralWidget(default.MainApp(self.Env))
        else:
            exit(0)

    def Suspend_act (self):
        import suspendpage
        self.Env.taskbar.hide()
        self.Env.setCentralWidget(suspendpage.MainApp(self.Env))

    def Lock_act (self):
        files.write ("/tmp/username.tmp",self.Env.username)
        apps.switch('desktop')
        import lock
        self.Env.taskbar.hide()
        self.Env.setCentralWidget(lock.MainApp(self.Env))
