from PyQt5.QtWidgets import *
from PyQt5 import *
from PyQt5.QtCore import *
from PyQt5.QtGui import *
from libnam import files,control
from libabr import app as apps

app = QApplication([])

class MainApp (QMainWindow):
    def __init__(self):
        super(MainApp, self).__init__()
        apps.start ("desktop")

        self.setObjectName('backend')

        cs = files.readall ("/proc/info/cs")
        cd = files.readall ("/proc/info/cd")
        ver = files.readall ("/proc/info/ver")
        self.setWindowTitle(cs+" "+ver+" ("+cd+")")

        model = control.read_record ("model","/etc/gui")
        model = model.split("x")
        mw = int(model[0])  # width of model
        mh = int(model[1])  # height of model

        self.setFixedSize(mw,mh)

        bgcolor = control.read_record("backend.bgcolor", "/etc/gui")

        if bgcolor == None:
            bgcolor = "#000000"

        self.setStyleSheet("background-color: " + bgcolor + ";")

        QTimer.singleShot(100, self.splashc)

        fullscreen = control.read_record("backend.fullscreen","/etc/gui")
        if fullscreen=="Yes": self.showFullScreen()
        else: self.show()

    def splashc(self):
        import splash
        self.setCentralWidget(splash.MainApp(self))