from PyQt5.QtWidgets import *
from PyQt5 import *
from PyQt5.QtCore import *
from PyQt5.QtGui import *
from PyQt5 import uic
from libnam import files, control, process
import importlib, hashlib
from importlib import reload
from libabr import core, file,res

from PyQt5 import QtCore, QtGui, QtWidgets

class MainApp (QMainWindow):
    fontsize = control.read_record("fontsize", "/etc/gui") # Get font size
    model = control.read_record("model", "/etc/gui") # Get screen model
    locale = control.read_record("locale","/etc/gui") # Get locale
    username = files.readall("/tmp/username.tmp") # Get username
    model = model.split("x")
    mw = int(model[0])  # width of model
    mh = int(model[1])  # height of model

    def suspend_act(self):
        import suspendpage
        importlib.reload(suspendpage) ##https://www.geeksforgeeks.org/reloading-modules-python/
        self.Backend.setCentralWidget (suspendpage.MainApp(self.Backend))
    def escape_act(self):
        core.shutdown()
        exit(0)
    def restart_act(self):
        core.reboot()
        exit(0)

    def desktop(self):
        self.close()
        import desktop
        self.Backend.setCentralWidget(desktop.MainApp(self.Backend))

    def check_password(self):
        self.password = self.lineEdit.text()

        self.hashcode = hashlib.sha3_512(
            str(self.password).encode()).hexdigest()

        self.code = control.read_record("code", "/etc/users/" + self.username)

        if self.hashcode == self.code:
            files.create("/tmp/su.tmp")
            control.write_record("username", self.username.lower(), "/tmp/su.tmp")
            control.write_record("code", self.lineEdit.text(), "/tmp/su.tmp")

            files.write("/proc/info/su", self.username)
            QTimer.singleShot(0,self.desktop)
        else:
            self.lblDown.setText(res.get("@string/lblWrongpassword"))
            QTimer.singleShot(1000, self.clear)

    ## Clear wrongs
    def clear(self):
        self.lblDown.clear()
        self.lineEdit.clear()

    def __init__(self,Backend):
        super(MainApp,self).__init__()
        ## Load ui ##
        # uic.loadUi(res.get('@widget/default'),self)
        self.setObjectName('enter')
        self.Backend = Backend
        self.setFixedSize(self.mw, self.mh)

        ## Background image button ##
        self.btnBackgroundImage = QtWidgets.QPushButton()
        self.setCentralWidget(self.btnBackgroundImage)

        ## MenuBar ##
        self.menubar = QMenuBar()
        self.setMenuBar(self.menubar)

        ## Frameless the window ##
        self.setWindowFlags(QtCore.Qt.FramelessWindowHint)

        ## Finds ##
        # self.btnAccountImage = self.findChild(QPushButton,'btnAccountImage')
        # self.lblTop = self.findChild(QLabel, 'lblTop')
        # self.lblDown = self.findChild(QLabel,'lblDown')
        self.menubar.setStyleSheet("background: none;")
        self.menuPower = self.menubar.addMenu('')
        self.actionEscape = self.menuPower.addAction('')
        self.actionRestart = self.menuPower.addAction('')
        self.actionSuspend = self.menuPower.addAction('')

        ## Font Size configure ##
        if self.fontsize == None:
            self.fontsize = 12
        else:
            self.fontsize = int(self.fontsize)

        ## Set layout direction

        if res.get("@string/menu_direction") == "rtl":
            self.menubar.setLayoutDirection(QtCore.Qt.RightToLeft)
        else:
            self.menubar.setLayoutDirection(QtCore.Qt.LeftToRight)

        ## Set locales all ##
        # self.lblTop.setText(res.get("@string/lblTop"))
        self.menuPower.setTitle(res.get("@string/menu_power"))
        self.actionRestart.setText(res.get("@string/action_restart"))
        self.actionEscape.setText(res.get("@string/action_escape"))
        self.actionSuspend.setText(res.get("@string/action_suspend"))

        ## Set fonts all ##
        # self.lblDown.setFont (QFont(res.get("@string/font"),self.fontsize))
        # self.lblTop.setFont(QFont(res.get("@string/font"), self.fontsize))
        self.menubar.setFont(QFont(res.get("@string/font"), self.fontsize))
        self.menuPower.setFont(QFont(res.get("@string/font"), self.fontsize))
        self.actionSuspend.setFont(QFont(res.get("@string/font"), self.fontsize))
        self.actionRestart.setFont(QFont(res.get("@string/font"), self.fontsize))
        self.actionEscape.setFont(QFont(res.get("@string/font"), self.fontsize))

        ## Set Actions ##
        self.actionEscape.triggered.connect(self.escape_act)
        self.actionRestart.triggered.connect(self.restart_act)
        self.actionSuspend.triggered.connect(self.suspend_act)

        ## PyCloud data
        self.cs = files.readall("/proc/info/cs")
        self.cd = files.readall("/proc/info/cd")
        self.ver = files.readall("/proc/info/ver")
        self.setWindowTitle(self.cs + " " + self.ver + " (" + self.cd + ")")

        ## Default bgcolor check ##
        bgcolor = control.read_record("login.bgcolor", "/etc/gui")
        background = res.get(control.read_record("login.background", "/etc/gui"))

        if not bgcolor == None:
            self.btnBackgroundImage.setStyleSheet("border: none;background-color: " + bgcolor + ";")
        elif not background == None:
            self.btnBackgroundImage.setStyleSheet("border: none;background-image: url(" + background + ");")
        else:
            self.btnBackgroundImage.setStyleSheet("border: none;background-color: purple;")

        ## Float login widget ##
        self.loginw = QWidget()
        uic.loadUi(res.get('@widget/enter'), self.loginw)
        self.loginw.setGeometry(int(self.mw / 2) - int(self.loginw.width() / 2), int(self.mh / 15), self.loginw.width(),
                                self.loginw.height())
        self.layout().addWidget(self.loginw)

        ## Userlogo ##
        self.userlogo = control.read_record("login.userlogo","/etc/users/"+self.username)
        if self.userlogo==None:
            self.userlogo = control.read_record("login.userlogo","/etc/gui")

        ## Finds ##
        self.btnAccountImage = self.findChild(QtWidgets.QPushButton, 'btnAccountImage')
        self.btnAccountImage.setStyleSheet('background-image: url(' + res.get(self.userlogo) + ');border-radius: 128% 128%;border-style: solid;border-color: gray;border-width: 1%')

        self.lblTop = self.findChild(QtWidgets.QLabel, 'lblTop')
        self.lblTop.setText(res.get("@string/lblPassword").replace("{0}",self.username))
        self.lblTop.setFont(QFont(res.get("@string/font"), self.fontsize))
        self.lblDown = self.findChild(QtWidgets.QLabel, 'lblDown')
        self.lblDown.setFont(QFont(res.get("@string/font"), self.fontsize))
        self.lineEdit = self.findChild(QtWidgets.QLineEdit, 'lineEdit')
        self.lineEdit.setFont(QFont(res.get("@string/font"), self.fontsize))
        self.lineEdit.returnPressed.connect(self.check_password)
        self.lineEdit.setEchoMode (QLineEdit.Password)

        ## Show default ##
        self.showFullScreen()