from PyQt5.QtWidgets import *
from PyQt5 import *
from PyQt5.QtCore import *
from PyQt5.QtGui import *
from libnam import files, control, permissions
from libabr import core, file, res
import hashlib, importlib,os,datetime,time

from PyQt5 import QtCore, QtGui, QtWidgets, uic


class MainApp (QtWidgets.QMainWindow):
    model = control.read_record("model", "/etc/gui")
    fontsize = control.read_record("fontsize", "/etc/gui")
    username = files.readall("/tmp/username.tmp")
    model = model.split("x")
    mw = int(model[0])  # width of model
    mh = int(model[1])  # height of model

    def unlock(self):
        import unlock
        importlib.reload(unlock)
        self.Backend.setCentralWidget (unlock.MainApp(self.Backend))
        self.Backend.taskbar.show()
        self.close()

    def unlock_act(self):
        if not self.Backend.username=="guest":
            self.unlock()
        else:
            self.Backend.taskbar.show()
            self.close()

    def getTime (self):
        ## Get timezone ##
        os.environ['TZ'] = files.readall(
            "/proc/info/tz")  # https://stackoverflow.com/questions/1301493/setting-timezone-in-python
        time.tzset()

        ## Get time format ##
        self.timeformat = control.read_record('lock.timeformat', '/etc/gui')

        ## Credit: https://www.w3resource.com/python-exercises/python-basic-exercise-3.php #
        # Get time ##

        self.now = datetime.datetime.now()

        if self.timeformat == None:
            self.timeformat = "hh:mm"

        ############

    def __init__(self,Backend):
        super().__init__()

        self.Backend = Backend
        self.setObjectName('lock')
        self.setFixedSize(self.mw,self.mh) # Set model sizes

        self.username = self.Backend.username

        self.getTime()

        # Finds #
        self.btnUnlock = QPushButton()
        self.btnUnlock.setFixedSize(self.mw,self.mh)

        ## Font Size configure ##
        if self.fontsize == None:
            self.fontsize = 12
        else:
            self.fontsize = int(self.fontsize)

        # Unlock action #
        self.btnUnlock.clicked.connect(self.unlock_act)

        ## Get distro database
        self.cs = files.readall("/proc/info/cs")
        self.cd = files.readall("/proc/info/cd")
        self.ver = files.readall("/proc/info/ver")
        self.setWindowTitle(self.cs + " " + self.ver + " (" + self.cd + ")")

        ## Default bgcolor check ##
        self.bgcolor = None
        if not self.username == "guest":
            self.bgcolor = control.read_record("unlock.bgcolor", "/etc/users/" + self.username)
        if self.bgcolor == None:
            self.bgcolor = control.read_record("unlock.bgcolor", "/etc/gui")
        self.background = None
        if not self.username == "guest":
            self.background = res.get(control.read_record("unlock.background", "/etc/users/" + self.username))
        if self.background == None:
            self.background = res.get(control.read_record("unlock.background", "/etc/gui"))

        if not self.bgcolor == None:
            self.btnUnlock.setStyleSheet("border: none;background-color: " + self.bgcolor + ";color: qlineargradient(spread:pad, x1:0, y1:0, x2:1, y2:1, stop:0 rgba(0, 186, 255, 255), stop:1 rgba(255, 255, 255, 255));")
        elif not self.background == None:
            self.btnUnlock.setStyleSheet("border: none;background-image: url(" + self.background + ");color: qlineargradient(spread:pad, x1:0, y1:0, x2:1, y2:1, stop:0 rgba(0, 186, 255, 255), stop:1 rgba(255, 255, 255, 255));")
        else:
            self.btnUnlock.setStyleSheet("border: none;background-image: url("+res.get('@background/default')+");color: qlineargradient(spread:pad, x1:0, y1:0, x2:1, y2:1, stop:0 rgba(0, 186, 255, 255), stop:1 rgba(255, 255, 255, 255));")

        # creating a timer object
        timer = QTimer(self)

        # adding action to timer
        timer.timeout.connect(self.showTime)

        # update the timer every second
        timer.start(1000)

        self.setCentralWidget(self.btnUnlock)
        self.showFullScreen()

    ## https://www.geeksforgeeks.org/pyqt5-create-a-digital-clock/ ##

    def showTime(self):
        # getting current time
        current_time = QTime.currentTime()

        # converting QTime object to string
        self.btnUnlock.setText(current_time.toString(self.timeformat))
        self.btnUnlock.setFont(QFont(res.get('@string/font'),self.fontsize*9))
