from PyQt5.QtWidgets import *
from PyQt5 import *
from PyQt5.QtCore import *
from PyQt5.QtGui import *
from libnam import files, control, permissions, process
from libabr import core, res,app
import hashlib, importlib

from PyQt5 import QtCore, QtGui, QtWidgets

from PyQt5.QtWidgets import *
from PyQt5 import *
from PyQt5.QtCore import *
from PyQt5.QtGui import *
from PyQt5 import uic
from libnam import files, control, process
import importlib, hashlib
from importlib import reload
from libabr import core, file

from PyQt5 import QtCore, QtGui, QtWidgets

class MainApp (QMainWindow):
    fontsize = control.read_record("fontsize", "/etc/gui") # Get font size
    model = control.read_record("model", "/etc/gui") # Get screen model
    locale = control.read_record("locale","/etc/gui") # Get locale
    username = files.readall("/tmp/username.tmp") # Get username
    model = model.split("x")
    mw = int(model[0])  # width of model
    mh = int(model[1])  # height of model

    def suspend_act(self):
        import suspendpage
        importlib.reload(suspendpage) ##https://www.geeksforgeeks.org/reloading-modules-python/
        self.Backend.setCentralWidget(suspendpage.MainApp(self.Backend))

    def escape_act(self):
        core.shutdown()
        exit(0)

    def restart_act(self):
        core.reboot()
        exit(0)

    def desktop(self):
        self.close()
        import desktop
        self.Backend.setCentralWidget(desktop.MainApp(self.Backend))

    def check_password(self):
        self.password = self.lineEdit.text()

        self.hashcode = hashlib.sha3_512(
            str(self.password).encode()).hexdigest()

        self.code = control.read_record("code", "/etc/users/" + self.username)

        if self.hashcode == self.code:
            self.close()
        else:
            self.lblDown.setText(res.get("@string/lblWrongpassword"))
            QTimer.singleShot(1000, self.clear)

    ## Clear wrongs
    def clear(self):
        self.lblDown.clear()
        self.lineEdit.clear()

    def __init__(self,Backend):
        super(MainApp,self).__init__()

        self.Backend = Backend
        ## Load ui ##
        self.setObjectName('unlock')
        # uic.loadUi(res.get('@widget/default'),self)

        self.setFixedSize(self.mw, self.mh)

        ## Frameless the window ##
        self.setWindowFlags(QtCore.Qt.FramelessWindowHint)

        ## Background image button ##
        self.btnBackgroundImage = QtWidgets.QPushButton()
        self.setCentralWidget(self.btnBackgroundImage)

        ## Font Size configure ##
        if self.fontsize == None:
            self.fontsize = 12
        else:
            self.fontsize = int(self.fontsize)

        ## PyCloud data
        self.cs = files.readall("/proc/info/cs")
        self.cd = files.readall("/proc/info/cd")
        self.ver = files.readall("/proc/info/ver")
        self.setWindowTitle(self.cs + " " + self.ver + " (" + self.cd + ")")

        ## Default bgcolor check ##
        bgcolor = control.read_record("login.bgcolor", "/etc/gui")
        background = res.get(control.read_record("login.background", "/etc/gui"))

        if not bgcolor == None:
            self.btnBackgroundImage.setStyleSheet("border: none;background-color: " + bgcolor + ";")
        elif not background == None:
            self.btnBackgroundImage.setStyleSheet("border: none;background-image: url(" + background + ");")
        else:
            self.btnBackgroundImage.setStyleSheet("border: none;background-color: purple;")

        ## Float login widget ##
        self.loginw = QWidget()
        uic.loadUi(res.get('@widget/enter'), self.loginw)
        self.loginw.setGeometry(int(self.mw / 2) - int(self.loginw.width() / 2), int(self.mh / 15), self.loginw.width(),
                                self.loginw.height())
        self.layout().addWidget(self.loginw)


        ## Userlogo ##
        self.userlogo = control.read_record("login.userlogo", "/etc/users/" + self.username)
        if self.userlogo == None:
            self.userlogo = control.read_record("login.userlogo", "/etc/gui")

        ## Finds ##
        self.btnAccountImage = self.findChild(QtWidgets.QPushButton, 'btnAccountImage')
        self.btnAccountImage.setStyleSheet('background-image: url(' + res.get(
            self.userlogo) + ');border-radius: 128% 128%;border-style: solid;border-color: gray;border-width: 1%')

        self.lblTop = self.findChild(QtWidgets.QLabel, 'lblTop')
        self.lblTop.setText(res.get("@string/lblPassword").replace("{0}", self.username))
        self.lblTop.setFont(QFont(res.get("@string/font"), self.fontsize))
        self.lblDown = self.findChild(QtWidgets.QLabel, 'lblDown')
        self.lblDown.setFont(QFont(res.get("@string/font"), self.fontsize))
        self.lineEdit = self.findChild(QtWidgets.QLineEdit, 'lineEdit')
        self.lineEdit.setFont(QFont(res.get("@string/font"), self.fontsize))
        self.lineEdit.returnPressed.connect(self.check_password)
        self.lineEdit.setEchoMode(QLineEdit.Password)