from PyQt5.QtWidgets import *
from PyQt5 import *
from PyQt5.QtCore import *
from PyQt5.QtGui import *
from libnam import files, control
from libabr import file, res, app
from PyQt5 import uic

class MainApp (QMainWindow):
    model = control.read_record("model", "/etc/gui") ## Get model control

    def login(self):
        self.close()
        self.type = control.read_record("login.type", "/etc/gui")
        if self.type == "default":
            import default
            self.Backend.setCentralWidget(default.MainApp(self.Backend))
        else:
            exit(0)

    model = model.split("x")
    mw = int(model[0])  # width of model
    mh = int(model[1])  # height of model

    def __init__(self,Backend):
        super().__init__()
        self.Backend = Backend
        self.setObjectName('splash')
        ## Load ui ##
        #uic.loadUi(res.get("@widget/splash"),self)
        self.setFixedSize(self.mw,self.mh)

        ## PyCloud data ##
        self.cs = files.readall("/proc/info/cs")
        self.cd = files.readall("/proc/info/cd")
        self.ver = files.readall("/proc/info/ver")
        self.setWindowTitle(self.cs + " " + self.ver + " (" + self.cd + ")")
        self.setCursor(QCursor(Qt.BlankCursor))

        ## Get media ##
        self.bgcolor = control.read_record("splash.bgcolor", "/etc/gui")

        if not self.bgcolor == None:
            self.setStyleSheet("background-color: " + self.bgcolor + ";")
        else:
            self.setStyleSheet("background-color: #ABCDEF;")

        ## Get timeout ##
        self.timeout = control.read_record("splash.timeout", "/etc/gui")
        if self.timeout == None:
            self.timeout = 3000
        else:
            self.timeout = int(self.timeout) * 1000

        QTimer.singleShot(self.timeout, self.login)

        ## Get Logo ##
        self.logo = res.get(control.read_record("splash.logo","/etc/gui"))
        self.logosize = control.read_record("splash.logosize","/etc/gui")
        if not self.logo == None:
            self.lbllogo = QWidget()

            ## Get logo size ##
            if not self.logosize==None:
                self.lbllogo.resize(int(self.logosize),int(self.logosize))
            else:
                self.lbllogo.resize(512,512)

            ## Set logo size image ##
            self.lbllogo.setStyleSheet('background-image: url('+self.logo+");")
            self.lbllogo.setGeometry(int(self.mw / 2) - int(self.lbllogo.width() / 2),int(self.mh / 2) - int(self.lbllogo.height() / 2),self.lbllogo.width(),self.lbllogo.height())
            self.layout().addWidget(self.lbllogo)

        ## Frameless the window ##
        self.setWindowFlags(Qt.FramelessWindowHint)

        ## Show screen ##
        self.showFullScreen()