
from libnam import process, files, permissions, colors, control
from libabr import app
import os, importlib, subprocess as sub

## Shutdown a switched process ## [#]
def end (name):
    su = files.readall ("/proc/info/su")
    interface = files.readall("/proc/info/inter")

    if interface=="CLI":
        process.end(name)
    else:
        app.end (name)

## Shutdown the clouding system ## [#]
def shutdown ():
    if files.isfile("/proc/selected"): files.remove("/proc/selected")
    if files.isdir("/desk/guest"):     files.removedirs("/desk/guest")
    app.endall()
    process.endall()

## Logout from gui session ##

def logout ():
    python = files.readall("/proc/info/py")
    interface = files.readall("/proc/info/inter")
    if files.isfile("/proc/selected"): files.remove("/proc/selected")
    app.endall()
    process.endall()
    if interface=="CLI":
        sub.call([python,files.readall("/proc/info/boot"),'login'])

## Switch user ##

def switchuser ():
    python = files.readall("/proc/info/py")
    interface = files.readall("/proc/info/inter")
    if interface == "CLI":
        sub.call([python,files.readall("/proc/info/boot"),'login'])

## Restart the clouding system ## [#]
def reboot ():
    py = files.readall("/proc/info/py")
    if files.isfile("/proc/selected"): files.remove("/proc/selected")
    if files.isdir("/desk/guest"):     files.removedirs("/desk/guest")
    app.endall()
    process.endall()
    sub.call([py,files.readall("/proc/info/boot")])

## Select a database ## [#]
def select (name):
    su = files.readall("/proc/info/su")
    if permissions.check(files.output(name), "r", su):
        if files.isfile(name):
            files.write("/proc/info/sel", name)
            files.create("/proc/selected")
        else:
            colors.show("libabr.core.select", "fail", name + ": database not found.")
    else:
        colors.show("libabr.core.select", "perm", "")

## Set a variable ## [#]
def set (name,value):
    su = files.readall("/proc/info/su")
    sel = files.readall("/proc/info/sel")
    if permissions.check(files.output(name), "w", su):
        control.write_record(name, value, sel)
    else:
        colors.show("libabr.core.set", "perm", "")

## Set a variable ## [#]
def unset (name):
    su = files.readall("/proc/info/su")
    sel = files.readall("/proc/info/sel")
    if permissions.check(files.output(name), "w", su):
        control.remove_record(name, sel)
    else:
        colors.show("libabr.core.unset", "perm", "")

## Unselect the database ## [#]
def unselect ():
    sp = files.readall("/proc/info/sp")
    sel = files.readall("/proc/info/sel")
    if sel == "/proc/" + sp:
        colors.show("libabr.core.unselect", "warning", "database has already selected.")
    else:
        files.write("/proc/info/sel", "/proc/" + sp)
        if files.isfile("/proc/selected"): files.remove("/proc/selected")

## Chmod ## [#]

def chmod (mod,name):
    su = files.readall("/proc/info/su")
    perm_user = int(mod[0])
    perm_others = int(mod[1])
    perm_guest = int(mod[2])
    if permissions.check_owner(files.output(name), su):
        owner = permissions.get_owner(files.output(name))
        permissions.create(files.output(name), perm_user, perm_others, perm_guest, owner)
    else:
        colors.show("libabr.core.chmod", "perm", "")

## System ##

def system (cmd):
    prompt = [files.readall ("/proc/info/py"),files.readall("/proc/info/boot"),'exec']
    cmdln = cmd.split(" ")
    cmdln.remove ('')
    for i in cmdln:
        prompt.append(i)
    sub.call(prompt)